unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, ShockwaveFlashObjects_TLB, StdCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    ShockwaveFlash1: TShockwaveFlash;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
{$R flash.res}

procedure TfrmMain.FormCreate(Sender: TObject);
var 
  SystemDir : array[0..MAX_PATH] of Char; 
  SWFDir, AppDir: String; 
  Fres: TResourceStream; 
  Ffile: TFileStream;
begin
    GetSystemDirectory(@SystemDir,MAX_PATH);
    SWFDir := SystemDir+'\macromed\flash\'; 
    GetDir(0,AppDir); // Get current directory

    //check whether the sw-flash ocx is already installed 
    if fileexists(SWFDir+'swflash.ocx')=false then begin 
        //create directories if needed and extract file from resource. 
        {$i-} //compiler directive to suppress i/o error messages 
        MkDir(SystemDir+'\macromed'); 
        MKDir(SystemDir+'\macromed\flash'); 
        {$i+} 
        Fres := TResourceStream.Create(0,'SHOCKWAVEOCX',RT_RCDATA); 
        Ffile := TFileStream.Create(SWFDir+'swflash.ocx',fmCreate); 
        try
          Ffile.CopyFrom(Fres,Fres.Size);
        finally
          Fres.Free;
          Ffile.Free;
        end;
        //register ocx (simple but useful) 
        Winexec(PChar('regsvr32 /s '+SWFDir+'swflash.ocx'),SW_HIDE);
    end; 
    // extract ShockwaveFile from resource to application directory 
    Fres := TResourceStream.Create(0,'SHOCKWAVEFILE',RT_RCDATA);
    Ffile := TFileStream.Create('flashmovie.swf',fmCreate);
    Try
      Ffile.CopyFrom(Fres,Fres.Size);
      Fres.Free;
    Finally
      Ffile.Free;
    end;
    //Assign the extracted swf file to your TShockwaveFlash object
    ShockwaveFlash1.Movie := AppDir+'\flashmovie.swf';
end; 


procedure TfrmMain.Button1Click(Sender: TObject);
begin
   ShockwaveFlash1.Stop;
end;

end.
